__inter_odd_and_two__mod__3(s(X)) :- __inter_even_and_one__mod__3(X).
__inter_odd_and_one__mod__3(s(X)) :- __inter_even_and_zero__mod__3(X).
__inter_even_and_one__mod__3(s(X)) :- __inter_odd_and_zero__mod__3(X).
r(X1,X2) :- __inter_odd_and_two__mod__3(X1), __inter_list__even_and_tree__3n__plus__2(X2).
__inter_even_and_tree__3n__plus__2(s(X)) :- __inter_odd_and_one__mod__3(X).
__inter_list__even_and_tree__3n__plus__2(nil).
__inter_list__even_and_tree__3n__plus__2(cons(X1,X2)) :- __inter_even_and_tree__3n__plus__2(X1), __inter_list__even_and_tree__3n__plus__2(X2).
__inter_even_and_two__mod__3(s(X)) :- __inter_odd_and_one__mod__3(X).
__inter_odd_and_zero__mod__3(s(X)) :- __inter_even_and_two__mod__3(X).
__inter_even_and_zero__mod__3(o).
__inter_even_and_zero__mod__3(s(X)) :- __inter_odd_and_two__mod__3(X).
